%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FDTD_3D_CPML
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear;
clear all;
clc;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
epsR = 1.0;
sigM1 = 0.0; 

pi = 3.14159265358979;
c0 = 2.99792458E8;
muO = 4.0 * pi * 1.0E-7; 
epsO = 1.0/(c0*c0*muO);
  
freq=1.9341e+14;
lambda=c0/freq;         
omega=2.0*pi*freq;

dx = 1.0E-3; dy = 1.0E-3; dz = 1.0E-3;
dt = 0.99 / (c0*(1.0/dx^2+1.0/dy^2)^0.5);

tw = 26.53E-12;      tO = 4.0*tw;

Imax = 40; 
Jmax = 40;
%Kmax = 50;



 %istart = (Imax-1)/2-11;
 %iend = istart+24; 
 %jstart = Jmax/2-49;
      
 %jend = jstart + 99; 
 %kstart = Kmax/2;
 %kend = kstart;      
%isource = (Imax-1)/2;
isource = (Imax)/2;
 
jsource = Jmax/2;
 %ksource = kstart;     
 %irecv1 = iend;
 %jrecv1 = jend+1;
 %krecv1 = kend;
 % Ey at probe point

%
%isource01 = (Imax-1)/2; 
%jsource01 = Jmax/2; 
%ksource01 = Kmax/2;
%isource02 = (Imax-1)/2+1; 
%jsource02 = (Jmax)/2; 
%ksource02 = (Kmax)/2;
%}
% PML thickness in each direction
nxPML_1 = 11; nxPML_2 = nxPML_1; nyPML_1 = nxPML_1;
nyPML_2 = nxPML_1; 
nzPML_1 = nxPML_1; nzPML_2 = nxPML_2;
%-------------------------
m = 3; ma = 1;

sig_x_max = 0.75 * (0.8*(m+1)/(dx*(muO/epsO*epsR)^0.5));
sig_y_max = 0.75 * (0.8*(m+1)/(dy*(muO/epsO*epsR)^0.5));
sig_z_max = 0.75 * (0.8*(m+1)/(dz*(muO/epsO*epsR)^0.5));
alpha_x_max = 0.2;
alpha_y_max = alpha_x_max; 
alpha_z_max = alpha_x_max;
kappa_x_max = 1;
kappa_y_max = kappa_x_max; 
kappa_z_max = kappa_x_max;

%Ex =zeros(Imax-1, Jmax, Kmax);Ey =zeros(Imax, Jmax-1, Kmax);
%Ez =zeros(Imax, Jmax, Kmax-1);
%Hx =zeros(Imax,Jmax-1, Kmax-1);Hy =zeros(Imax-1, Jmax, Kmax-1);
%Hz =zeros(Imax-1, Jmax-1, Kmax); 
Ez =zeros(Imax, Jmax);
Hx =zeros(Imax,Jmax-1);Hy =zeros(Imax-1, Jmax);
      
%CA  =zeros(Imax, Jmax, Kmax-1);
%CB  =zeros(Imax, Jmax, Kmax-1);
%sig =zeros(Imax, Jmax, Kmax-1);
%eps=zeros(Imax, Jmax, Kmax-1); 

CA  =zeros(Imax, Jmax);
CB  =zeros(Imax, Jmax);
sig =zeros(Imax, Jmax);
eps=zeros(Imax, Jmax); 

NoFig=29;
Nplt_jmp=5;
%***********************************************************************
%     Differentiated Gaussian pulse excitation
%***********************************************************************
rtau=50.0e-12;
tau=rtau/dt;
ndelay=3*tau;
srcconst=-dt*3.0e+11;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%  CPML 
%psi_Exy_1=zeros(Imax-1,nyPML_1,Kmax);psi_Exy_2=zeros(Imax-1,nyPML_2,Kmax);

%psi_Exz_1=zeros(Imax-1,Jmax,nzPML_1);psi_Exz_2=zeros(Imax-1,Jmax,nzPML_2);

%psi_Eyz_1=zeros(Imax,Jmax-1,nzPML_1);psi_Eyz_2=zeros(Imax,Jmax-1,nzPML_2);

%psi_Eyx_1=zeros(nxPML_1,Jmax-1,Kmax);psi_Eyx_2=zeros(nxPML_2,Jmax-1,Kmax);

%psi_Ezx_1=zeros(nxPML_1,Jmax);psi_Ezx_2=zeros(nxPML_2,Jmax,Kmax);

%psi_Ezy_1=zeros(Imax,nyPML_1);psi_Ezy_2=zeros(Imax,nyPML_2,Kmax);


%psi_Exy_1=zeros(Imax-1,nyPML_1,Kmax);psi_Exy_2=zeros(Imax-1,nyPML_2,Kmax);

%psi_Exz_1=zeros(Imax-1,Jmax,nzPML_1);psi_Exz_2=zeros(Imax-1,Jmax,nzPML_2);

%psi_Eyz_1=zeros(Imax,Jmax-1,nzPML_1);psi_Eyz_2=zeros(Imax,Jmax-1,nzPML_2);

%psi_Eyx_1=zeros(nxPML_1,Jmax-1,Kmax);psi_Eyx_2=zeros(nxPML_2,Jmax-1,Kmax);

psi_Ezx_1=zeros(nxPML_1,Jmax);psi_Ezx_2=zeros(nxPML_2,Jmax);

psi_Ezy_1=zeros(Imax,nyPML_1);psi_Ezy_2=zeros(Imax,nyPML_2);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
psi_Hxy_1=zeros(Imax,nyPML_1-1);psi_Hxy_2=zeros(Imax,nyPML_2-1);

%psi_Hxz_1=zeros(Imax,Jmax-1,nzPML_1-1);psi_Hxz_2=zeros(Imax,Jmax-1,nzPML_2-1);

%psi_Hyz_1=zeros(Imax-1,Jmax,nzPML_1-1);psi_Hyz_2=zeros(Imax-1,Jmax,nzPML_2-1);

psi_Hyx_1=zeros(nxPML_1-1,Jmax);psi_Hyx_2=zeros(nxPML_2-1,Jmax); 

%psi_Hzx_1=zeros(nxPML_1-1,Jmax-1,Kmax);psi_Hzx_2=zeros(nxPML_2-1,Jmax-1,Kmax);

%psi_Hzy_1=zeros(Imax-1,nyPML_1-1,Kmax);psi_Hzy_2=zeros(Imax-1,nyPML_2-1,Kmax);        
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
% E-Field
% x-dir
be_x_1=zeros(nxPML_1,1);
ce_x_1=zeros(nxPML_1,1);
alphae_x_PML_1=zeros(nxPML_1,1);
sige_x_PML_1=zeros(nxPML_1,1);
kappae_x_PML_1=zeros(nxPML_1,1);
be_x_2=zeros(nxPML_2,1);
ce_x_2=zeros(nxPML_2,1);
alphae_x_PML_2=zeros(nxPML_2,1);
sige_x_PML_2=zeros(nxPML_2,1);
kappae_x_PML_2=zeros(nxPML_2,1);
% y-dir
be_y_1=zeros(nyPML_1,1);
ce_y_1=zeros(nyPML_1,1);
alphae_y_PML_1=zeros(nyPML_1,1);
sige_y_PML_1=zeros(nyPML_1,1);
kappae_y_PML_1=zeros(nyPML_1,1);
be_y_2=zeros(nyPML_2,1);
ce_y_2=zeros(nyPML_2,1);
alphae_y_PML_2=zeros(nyPML_2,1);
sige_y_PML_2=zeros(nyPML_2,1);
kappae_y_PML_2=zeros(nyPML_2,1);
% z-dir
%be_z_1=zeros(nzPML_1,1);
%ce_z_1=zeros(nzPML_1,1);
%alphae_z_PML_1=zeros(nzPML_1,1);
%sige_z_PML_1=zeros(nzPML_1,1);
%kappae_z_PML_1=zeros(nzPML_1,1);
%be_z_2=zeros(nzPML_2,1);
%ce_z_2=zeros(nzPML_2,1);
%alphae_z_PML_2=zeros(nzPML_2,1);
%sige_z_PML_2=zeros(nzPML_2,1);
%kappae_z_PML_2=zeros(nzPML_2,1);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% H-Field
% x-dir
bh_x_1=zeros(nxPML_1-1,1);
ch_x_1=zeros(nxPML_1-1,1);
alphah_x_PML_1=zeros(nxPML_1-1,1);
sigh_x_PML_1=zeros(nxPML_1-1,1);
kappah_x_PML_1=zeros(nxPML_1-1,1);
bh_x_2=zeros(nxPML_2-1,1);
ch_x_2=zeros(nxPML_2-1,1);
alphah_x_PML_2=zeros(nxPML_2-1,1);
sigh_x_PML_2=zeros(nxPML_2-1,1);
kappah_x_PML_2=zeros(nxPML_2-1,1);
% y-dir
bh_y_1=zeros(nyPML_1-1,1);
ch_y_1=zeros(nyPML_1-1,1);
alphah_y_PML_1=zeros(nyPML_1-1,1);
sigh_y_PML_1=zeros(nyPML_1-1,1);
kappah_y_PML_1=zeros(nyPML_1-1,1);
bh_y_2=zeros(nyPML_2-1,1);
ch_y_2=zeros(nyPML_2-1,1);
alphah_y_PML_2=zeros(nyPML_2-1,1);
sigh_y_PML_2=zeros(nyPML_2-1,1);
kappah_y_PML_2=zeros(nyPML_2-1,1);
% z-dir
%bh_z_1=zeros(nzPML_1-1,1);
%ch_z_1=zeros(nzPML_1-1,1);
%alphah_z_PML_1=zeros(nzPML_1-1,1);
%sigh_z_PML_1=zeros(nzPML_1-1,1);
%kappah_z_PML_1=zeros(nzPML_1-1,1);
%bh_z_2=zeros(nzPML_2-1,1);
%ch_z_2=zeros(nzPML_2-1,1);
%alphah_z_PML_2=zeros(nzPML_2-1,1);
%sigh_z_PML_2=zeros(nzPML_2-1,1);
%kappah_z_PML_2=zeros(nzPML_2-1,1);



% Denominators for the update equations 
den_ex=zeros(Imax-1,1);
den_hx=zeros(Imax-1,1);
 
den_ey=zeros(Jmax-1,1);
den_hy=zeros(Jmax-1,1);
 
den_ez=zeros(Jmax-1,1);
%den_hz=zeros(Kmax-1,1);
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
%  INITIALIZE VARIABLES
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
sig(:,:) = sigM1;
eps(:,:) = epsR*epsO;
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
%  SET CPML PARAMETERS IN EACH DIRECTION
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  %x-dir

   for i = 1:nxPML_1
      sige_x_PML_1(i) = sig_x_max * ( (nxPML_1 - i) / (nxPML_1 - 1.0) )^m;
      alphae_x_PML_1(i) = alpha_x_max*((i-1.0)/(nxPML_1-1.0))^ma;
      kappae_x_PML_1(i) = 1.0+(kappa_x_max-1.0)*((nxPML_1 - i) / (nxPML_1 - 1.0))^m;
      be_x_1(i) = exp(-(sige_x_PML_1(i) / kappae_x_PML_1(i) + alphae_x_PML_1(i))*dt/epsO);
      if ((sige_x_PML_1(i) == 0.0) && (alphae_x_PML_1(i) == 0.0) && (i == nxPML_1)) 
         ce_x_1(i) = 0.0;
      else
         ce_x_1(i) = sige_x_PML_1(i)*(be_x_1(i)-1.0)/(sige_x_PML_1(i)+kappae_x_PML_1(i)*alphae_x_PML_1(i))/ kappae_x_PML_1(i);
      end
   end
   for i = 1:nxPML_1-1
      sigh_x_PML_1(i) = sig_x_max * ( (nxPML_1 - i - 0.5)/(nxPML_1-1.0))^m;
      alphah_x_PML_1(i) = alpha_x_max*((i-0.5)/(nxPML_1-1.0))^ma;
      kappah_x_PML_1(i) = 1.0+(kappa_x_max-1.0)*((nxPML_1 - i - 0.5) / (nxPML_1 - 1.0))^m;
      bh_x_1(i) = exp(-(sigh_x_PML_1(i) / kappah_x_PML_1(i) + alphah_x_PML_1(i))*dt/epsO);
      ch_x_1(i) = sigh_x_PML_1(i)*(bh_x_1(i)-1.0)/(sigh_x_PML_1(i)+kappah_x_PML_1(i)*alphah_x_PML_1(i))/ kappah_x_PML_1(i);
   end
%-------------------
   for i = 1:nxPML_2
      sige_x_PML_2(i) = sig_x_max * ( (nxPML_2 - i) / (nxPML_2 - 1.0) )^m;
      alphae_x_PML_2(i) = alpha_x_max*((i-1.0)/(nxPML_2-1.0))^ma;
      kappae_x_PML_2(i) = 1.0+(kappa_x_max-1.0)*((nxPML_2 - i) / (nxPML_2 - 1.0))^m;
      be_x_2(i) = exp(-(sige_x_PML_2(i) / kappae_x_PML_2(i) + alphae_x_PML_2(i))*dt/epsO);
      if ((sige_x_PML_2(i) == 0.0) && (alphae_x_PML_2(i) == 0.0) && (i == nxPML_2)) 
        ce_x_2(i) = 0.0;
      else
         ce_x_2(i) = sige_x_PML_2(i)*(be_x_2(i)-1.0)/(sige_x_PML_2(i)+kappae_x_PML_2(i)*alphae_x_PML_2(i))/ kappae_x_PML_2(i);
      end
   end
   for i = 1:nxPML_2-1
      sigh_x_PML_2(i) = sig_x_max * ( (nxPML_2 - i - 0.5)/(nxPML_2-1.0))^m;
      alphah_x_PML_2(i) = alpha_x_max*((i-0.5)/(nxPML_2-1.0))^ma;
      kappah_x_PML_2(i) = 1.0+(kappa_x_max-1.0)*((nxPML_2 - i - 0.5) / (nxPML_2 - 1.0))^m;
      bh_x_2(i) = exp(-(sigh_x_PML_2(i) / kappah_x_PML_2(i) + alphah_x_PML_2(i))*dt/epsO);
      ch_x_2(i) = sigh_x_PML_2(i)*(bh_x_2(i)-1.0)/(sigh_x_PML_2(i)+kappah_x_PML_2(i)*alphah_x_PML_2(i))/ kappah_x_PML_2(i);
   end
%  y-dir

   for j = 1:nyPML_1
      sige_y_PML_1(j) = sig_y_max * ( (nyPML_1 - j ) / (nyPML_1 - 1.0) )^m;
      alphae_y_PML_1(j) = alpha_y_max*((j-1)/(nyPML_1-1.0))^ma;
      kappae_y_PML_1(j) = 1.0+(kappa_y_max-1.0)*((nyPML_1 - j) / (nyPML_1 - 1.0))^m;
      be_y_1(j) = exp(-(sige_y_PML_1(j) / kappae_y_PML_1(j) + alphae_y_PML_1(j))*dt/epsO);
      if ((sige_y_PML_1(j) == 0.0) && (alphae_y_PML_1(j) == 0.0) && (j == nyPML_1))
         ce_y_1(j) = 0.0;
      else
         ce_y_1(j) = sige_y_PML_1(j)*(be_y_1(j)-1.0)/(sige_y_PML_1(j)+kappae_y_PML_1(j)*alphae_y_PML_1(j))/ kappae_y_PML_1(j);
      end
   end
   for j = 1:nyPML_1-1
      sigh_y_PML_1(j) = sig_y_max * ( (nyPML_1 - j - 0.5)/(nyPML_1-1.0))^m;
      alphah_y_PML_1(j) = alpha_y_max*((j-0.5)/(nyPML_1-1.0))^ma;
      kappah_y_PML_1(j) = 1.0+(kappa_y_max-1.0)*((nyPML_1 - j - 0.5) / (nyPML_1 - 1.0))^m;
      bh_y_1(j) = exp(-(sigh_y_PML_1(j) / kappah_y_PML_1(j) + alphah_y_PML_1(j))*dt/epsO);
      ch_y_1(j) = sigh_y_PML_1(j)*(bh_y_1(j)-1.0)/(sigh_y_PML_1(j)+kappah_y_PML_1(j)*alphah_y_PML_1(j))/ kappah_y_PML_1(j);
   end
%-------------------
   for j = 1:nyPML_2
      sige_y_PML_2(j) = sig_y_max * ( (nyPML_2 - j ) / (nyPML_2 - 1.0) )^m;
      alphae_y_PML_2(j) = alpha_y_max*((j-1)/(nyPML_2-1.0))^ma;
      kappae_y_PML_2(j) = 1.0+(kappa_y_max-1.0)*((nyPML_2 - j) / (nyPML_2 - 1.0))^m;
      be_y_2(j) = exp(-(sige_y_PML_2(j) / kappae_y_PML_2(j) + alphae_y_PML_2(j))*dt/epsO);
      if ((sige_y_PML_2(j) == 0.0) && (alphae_y_PML_2(j) == 0.0) && (j == nyPML_2))
         ce_y_2(j) = 0.0;
      else
         ce_y_2(j) = sige_y_PML_2(j)*(be_y_2(j)-1.0)/(sige_y_PML_2(j)+kappae_y_PML_2(j)*alphae_y_PML_2(j))/ kappae_y_PML_2(j);
      end
      end

      for j = 1:nyPML_2-1
      sigh_y_PML_2(j) = sig_y_max * ( (nyPML_2 - j - 0.5)/(nyPML_2-1.0))^m;
      alphah_y_PML_2(j) = alpha_y_max*((j-0.5)/(nyPML_2-1.0))^ma;
      kappah_y_PML_2(j) = 1.0+(kappa_y_max-1.0)*((nyPML_2 - j - 0.5) / (nyPML_2 - 1.0))^m;
      bh_y_2(j) = exp(-(sigh_y_PML_2(j) / kappah_y_PML_2(j) + alphah_y_PML_2(j))*dt/epsO);
      ch_y_2(j) = sigh_y_PML_2(j)*(bh_y_2(j)-1.0)/(sigh_y_PML_2(j)+kappah_y_PML_2(j)*alphah_y_PML_2(j))/ kappah_y_PML_2(j);
      end
%  k-dir
% 
   for k = 1:nzPML_1
      sige_z_PML_1(k) = sig_z_max * ( (nzPML_1 - k ) / (nzPML_1 - 1.0) )^m;
      alphae_z_PML_1(k) = alpha_z_max*((k-1)/(nzPML_1-1.0))^ma;
      kappae_z_PML_1(k) = 1.0+(kappa_z_max-1.0)*((nzPML_1 - k) / (nzPML_1 - 1.0))^m;
      be_z_1(k) = exp(-(sige_z_PML_1(k) / kappae_z_PML_1(k) + alphae_z_PML_1(k))*dt/epsO);
      if ((sige_z_PML_1(k) == 0.0) && (alphae_z_PML_1(k) == 0.0) && (k == nzPML_1))
         ce_z_1(k) = 0.0;
      else
         ce_z_1(k) = sige_z_PML_1(k)*(be_z_1(k)-1.0)/(sige_z_PML_1(k)+kappae_z_PML_1(k)*alphae_z_PML_1(k))/ kappae_z_PML_1(k);
      end
   end
   for k = 1:nzPML_1-1
      sigh_z_PML_1(k) = sig_z_max * ( (nzPML_1 - k - 0.5)/(nzPML_1-1.0))^m;
      alphah_z_PML_1(k) = alpha_z_max*((k-0.5)/(nzPML_1-1.0))^ma;
      kappah_z_PML_1(k) = 1.0+(kappa_z_max-1.0)*((nzPML_1 - k - 0.5) / (nzPML_1 - 1.0))^m;
      bh_z_1(k) = exp(-(sigh_z_PML_1(k) / kappah_z_PML_1(k) + alphah_z_PML_1(k))*dt/epsO);
      ch_z_1(k) = sigh_z_PML_1(k)*(bh_z_1(k)-1.0)/(sigh_z_PML_1(k)+kappah_z_PML_1(k)*alphah_z_PML_1(k))/ kappah_z_PML_1(k);
   end   
 %-------------------  
  for k = 1:nzPML_2
      sige_z_PML_2(k) = sig_z_max * ( (nzPML_2 - k ) / (nzPML_2 - 1.0) )^m;
      alphae_z_PML_2(k) = alpha_z_max*((k-1)/(nzPML_2-1.0))^ma;
      kappae_z_PML_2(k) = 1.0+(kappa_z_max-1.0)*((nzPML_2 - k) / (nzPML_2 - 1.0))^m;
      be_z_2(k) = exp(-(sige_z_PML_2(k) / kappae_z_PML_2(k) + alphae_z_PML_2(k))*dt/epsO);
      if ((sige_z_PML_2(k) == 0.0) && (alphae_z_PML_2(k) == 0.0) && (k == nzPML_2))
        ce_z_2(k) = 0.0;
      else
         ce_z_2(k) = sige_z_PML_2(k)*(be_z_2(k)-1.0)/(sige_z_PML_2(k)+kappae_z_PML_2(k)*alphae_z_PML_2(k))/ kappae_z_PML_2(k);
      end
   end
   %for k = 1:nzPML_2-1
      %sigh_z_PML_2(k) = sig_z_max * ( (nzPML_2 - k - 0.5)/(nzPML_2-1.0))^m;
      %alphah_z_PML_2(k) = alpha_z_max*((k-0.5)/(nzPML_2-1.0))^ma;
      %kappah_z_PML_2(k) = 1.0+(kappa_z_max-1.0)*((nzPML_2 - k - 0.5) / (nzPML_2 - 1.0))^m;
      %bh_z_2(k) = exp(-(sigh_z_PML_2(k) / kappah_z_PML_2(k) + alphah_z_PML_2(k))*dt/epsO);
      %ch_z_2(k) = sigh_z_PML_2(k)*(bh_z_2(k)-1.0)/(sigh_z_PML_2(k)+kappah_z_PML_2(k)*alphah_z_PML_2(k))/ kappah_z_PML_2(k);
   %end   
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
%  FILL IN UPDATING COEFFICIENTS
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   DA = 1.0;
   DB = (dt/(muO));
   for i = 1:Imax
      for j = 1:Jmax
         %for k = 1:Kmax-1
            CA(i,j) = (1.0 - sig(i,j)*dt / (2.0*eps(i,j))) / (1.0 + sig(i,j) * dt / (2.0*eps(i,j)));
            CB(i,j) = (dt/(eps(i,j))) / (1.0 + sig(i,j)*dt / (2.0*eps(i,j)));
         %end
      end
   end
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
%  FILL IN DENOMINATORS FOR FIELD UPDATES
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   ii = nxPML_2-1;
   for i = 1:Imax-1
      if (i <= nxPML_1-1)
         den_hx(i) = 1.0/(kappah_x_PML_1(i)*dx);
      elseif (i >= Imax+1-nxPML_2)
         den_hx(i) = 1.0/(kappah_x_PML_2(ii)*dx);
         ii = ii-1;
      else
         den_hx(i) = 1.0/dx
      end
   end
   jj = nyPML_2-1;
   for j = 1:Jmax-1
      if (j <= nyPML_1-1) 
         den_hy(j) = 1.0/(kappah_y_PML_1(j)*dy);
      elseif (j >= Jmax+1-nyPML_2) 
         den_hy(j) = 1.0/(kappah_y_PML_2(jj)*dy);
         jj = jj-1;
      else
         den_hy(j) = 1.0/dy;
      end
   end
   %kk = nzPML_2-1;
   %for k = 1:Kmax-1
     % if (k <= nzPML_1-1) 
         %den_hz(k) = 1.0/(kappah_z_PML_1(k)*dz);
      %elseif (k >= Kmax+1-nzPML_2)
         %den_hz(k) = 1.0/(kappah_z_PML_2(kk)*dz);
         %kk = kk - 1;
      %else
         %den_hz(k) = 1.0/dz;
      %end
   %end
 %-------------------  
   ii = nxPML_2;
   for i = 1:Imax-1
      if (i <= nxPML_1)
         den_ex(i) = 1.0/(kappae_x_PML_1(i)*dx);
      elseif (i >= Imax+1-nxPML_2)
         den_ex(i) = 1.0/(kappae_x_PML_2(ii)*dx);
         ii = ii-1;
      else
         den_ex(i) = 1.0/dx;
      end
   end
   jj = nyPML_2;
   for j = 1:Jmax-1
      if (j <= nyPML_1)
         den_ey(j) = 1.0/(kappae_y_PML_1(j)*dy);
      elseif (j >= Jmax+1-nyPML_2)
         den_ey(j) = 1.0/(kappae_y_PML_2(jj)*dy);
         jj = jj-1;
      else
         den_ey(j) = 1.0/dy;
      end
   end
   kk = nzPML_2;
   for k = 1:Jmax-1
      if (k <= nzPML_1) 
         den_ez(k) = 1.0/(kappae_z_PML_1(k)*dz);
      elseif (k >= Jmax+1-nzPML_2)
         den_ez(k) = 1.0/(kappae_z_PML_2(kk)*dz);
         kk = kk - 1;
      else
         den_ez(k) = 1.0/dz;
      end
   end
   
   %%Eref
   
 nmax=1000;
 
ez_ref_a=zeros(nmax,1);
ez_ref_b=zeros(nmax,1);

%ez_ref_max_a=zeros(nmax,1);
%ez_ref_max_b=zeros(nmax,1);
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
%  BEGIN TIME STEP
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  
for n = 1:nmax;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 %UPDATE Ez
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   %for k = 1:Kmax-1
    
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
%  UPDATE Hx
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   %for k = 1:Kmax-1
      for i = 1:Imax-1
        for j = 1:Jmax-1
        Hx(i,j) = DA * Hx(i,j) + DB * (Ez(i,j) - Ez(i,j+1))*den_hy(j);  
       %Hx(i,j,k) = DA * Hx(i,j,k) + DB * ( (Ez(i,j,k) - Ez(i,j+1,k))*den_hy(j)  +  (Ey(i,j,k+1) - Ey(i,j,k))*den_hz(k) );
       
        end
      end
      
      for i = 1:Imax-1
%.....................................................................
%  PML for bottom Hx, j-direction
%.....................................................................
         for j = 1:nyPML_1-1
         psi_Hxy_1(i,j) = bh_y_1(j)*psi_Hxy_1(i,j)+ ch_y_1(j) *(Ez(i,j) - Ez(i,j+1))/dy;
         Hx(i,j) = Hx(i,j) + DB*psi_Hxy_1(i,j);
         end
%.....................................................................
%  PML for top Hx, j-direction
%.....................................................................
         jj = nyPML_2-1;
         for j = Jmax+1-nyPML_2:Jmax-1
         psi_Hxy_2(i,jj) = bh_y_2(jj)*psi_Hxy_2(i,jj) + ch_y_2(jj) *(Ez(i,j) - Ez(i,(j+1)))/dy;
         Hx(i,j) = Hx(i,j) + DB*psi_Hxy_2(i,jj);
            jj = jj-1;
         end
      end
   
   %for i = 1:Imax-1
      %for j = 1:Jmax-1
%.....................................................................
%  PML for bottom Hx, k-direction
%.....................................................................
         %for k = 1:nzPML_1-1
         %psi_Hxz_1(i,j) = bh_z_1(k)*psi_Hxz_1(i,j)+ ch_z_1(k) *(Ey(i,j) - Ey(i,j))/dz;
         %Hx(i,j) = Hx(i,j) + DB*psi_Hxz_1(i,j);
         %end
%.....................................................................
%  PML for top Hx, k-direction
%.....................................................................
         %kk = nzPML_2-1;
         %for k = Kmax+1-nzPML_2:Kmax-1
         %psi_Hxz_2(i,j,kk) = bh_z_2(kk)*psi_Hxz_2(i,j,kk)+ ch_z_2(kk) *(Ey(i,j,k+1) - Ey(i,j,k))/dz;
         %Hx(i,j,k) = Hx(i,j,k) + DB*psi_Hxz_2(i,j,kk);
           %kk = kk-1;
         %end
      %end
   %end
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
%  UPDATE Hy
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   %for k = 1:Kmax-1
   for i = 1:Imax-1
    for j = 1:Jmax-1
            Hy(i,j) = DA * Hy(i,j) + DB *(Ez(i+1,j) - Ez(i,j))*den_hx(i);
    end
   end

   for j = 1:Jmax-1
%.....................................................................
%  PML for bottom Hy, i-direction
%.....................................................................
         for i = 1:nxPML_1-1
       psi_Hyx_1(i,j) = bh_x_1(i)*psi_Hyx_1(i,j)+ ch_x_1(i)*(Ez(i+1,j) - Ez(i,j))/dx;
       Hy(i,j) = Hy(i,j) + DB*psi_Hyx_1(i,j);
         end
%.....................................................................
%  PML for top Hy, i-direction
%.....................................................................
         ii = nxPML_2-1;
         for i = Imax+1-nxPML_2:Imax-1
       psi_Hyx_2(ii,j) = bh_x_2(ii)*psi_Hyx_2(ii,j)+ ch_x_2(ii)*(Ez(i+1,j) - Ez(i,j))/dx;
       Hy(i,j) = Hy(i,j) + DB*psi_Hyx_2(ii,j);
            ii = ii-1;
         end
   end
   
   for i = 2:Imax-1
        
         for j = 2:Jmax-1
            Ez(i,j) = CA(i,j) * Ez(i,j) + CB(i,j)* ((Hy(i,j) - Hy(i-1,j))*den_ex(i) + (Hx(i,j-1) - Hx(i,j))*den_ey(j));
        end
    end
    
    %ez_ref_a(n,1)=Ez(52,520);
    %ez_ref_b(n,1)=Ez(52,988);
    
    %ez_au10(n,1)=Ez(2,20);
    %ez_bu10(n,1)=Ez(2,38);
    
    
      for j = 2:Jmax-1
%.....................................................................
%  PML for bottom Ez, x-direction
%.....................................................................
         for i = 2:nxPML_1
          psi_Ezx_1(i,j) = be_x_1(i)*psi_Ezx_1(i,j)+ ce_x_1(i) *(Hy(i,j) - Hy(i-1,j))/dx;
          Ez(i,j) = Ez(i,j) + CB(i,j)*psi_Ezx_1(i,j);
         end
%.....................................................................
%  PML for top Ez, x-direction
%.....................................................................
         ii = nxPML_2;
         for i = Imax+1-nxPML_2:Imax-1
          psi_Ezx_2(ii,j) = be_x_2(ii)*psi_Ezx_2(ii,j)+ ce_x_2(ii) *(Hy(i,j) - Hy(i-1,j))/dx;
          Ez(i,j) = Ez(i,j) + CB(i,j)*psi_Ezx_2(ii,j);
            ii = ii-1;
         end
      end
      for i = 2:Imax-1
%.....................................................................
%  PML for bottom Ez, y-direction
%.....................................................................
         for j = 2:nyPML_1
            psi_Ezy_1(i,j) = be_y_1(j)*psi_Ezy_1(i,j)+ ce_y_1(j)*(Hx(i,j-1) - Hx(i,j))/dy;
            Ez(i,j) = Ez(i,j) + CB(i,j)*psi_Ezy_1(i,j);
         end
%.....................................................................
%  PML for top Ez, y-direction
%.....................................................................
         jj = nyPML_2;
         for j = Jmax+1-nyPML_2:Jmax-1
            psi_Ezy_2(i,jj) = be_y_2(jj)*psi_Ezy_2(i,jj)+ ce_y_2(jj)*(Hx(i,j-1) - Hx(i,j))/dy;
            Ez(i,j) = Ez(i,j) + CB(i,j)*psi_Ezy_2(i,jj);
            jj = jj-1;
         end
      end
    i=isource;
    j=jsource;
   %source = -2.0*((n*dt-tO)/tw) * exp(-((n*dt-tO)/tw)^2.0);
   %Ez(i,j) = Ez(i,j) - CB(i,j)*source;  
   
   source = -2.0*((n*dt-tO)/tw) * exp(-((n*dt-tO)/tw)^2.0);
   Ez(i,j) = source;  
      
      
   

   
   %for i = 1:Imax-1
      %for j = 1:Jmax-1
%.....................................................................
%  PML for bottom Hy, k-direction
%.....................................................................
         %for k = 1:nzPML_1-1
       %psi_Hyz_1(i,j) = bh_z_1(k)*psi_Hyz_1(i,j)+ ch_z_1(k)*(Ex(i,j) - Ex(i,j))/dz;
       %Hy(i,j,k) = Hy(i,j) + DB*psi_Hyz_1(i,j);
        % end
%.....................................................................
%  PML for top Hy, k-direction
%.....................................................................
         %kk = nzPML_2-1;
         %for k = Kmax+1-nzPML_2:Kmax-1
     %psi_Hyz_2(i,j) = bh_z_2(kk)*psi_Hyz_2(i,j)+ ch_z_2(kk)*(Ex(i,j) - Ex(i,j))/dz;
     %Hy(i,j,k) = Hy(i,j,k) + DB*psi_Hyz_2(i,j,kk);
           % kk = kk-1;
         %end
      %end
   %end
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
%  UPDATE Hz
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   %for k = 2:Kmax-1
      %for i = 1:Imax-1
       % for j = 1:Jmax-1
         %   Hz(i,j,k) = DA * Hz(i,j,k) + DB* ((Ey(i,j,k) - Ey(i+1,j,k))*den_hx(i) +  (Ex(i,j+1,k) - Ex(i,j,k))*den_hy(j));
        %end
      %end
      %for j = 1:Jmax-1
%.....................................................................
%  PML for bottom Hz, x-direction
%.....................................................................
         %for i = 1:nxPML_1-1
          %psi_Hzx_1(i,j,k) = bh_x_1(i)*psi_Hzx_1(i,j,k)+ ch_x_1(i) *(Ey(i,j,k) - Ey(i+1,j,k))/dx;
          %Hz(i,j,k) = Hz(i,j,k) + DB*psi_Hzx_1(i,j,k);
         %end
%.....................................................................
%  PML for top Hz, x-direction
%.....................................................................
         %ii = nxPML_2-1;
         %for i = Imax+1-nxPML_2:Imax-1
          %psi_Hzx_2(ii,j,k) = bh_x_2(ii)*psi_Hzx_2(ii,j,k)+ ch_x_2(ii) *(Ey(i,j,k) - Ey(i+1,j,k))/dx;
          %Hz(i,j,k) = Hz(i,j,k) + DB*psi_Hzx_2(ii,j,k);
           % ii = ii-1;
        % end
      %end
      %for i = 1:Imax-1
%.....................................................................
%  PML for bottom Hz, y-direction
%.....................................................................
         %for j = 1:nyPML_1-1
            %psi_Hzy_1(i,j,k) = bh_y_1(j)*psi_Hzy_1(i,j,k)+ ch_y_1(j)*(Ex(i,j+1,k) - Ex(i,j,k))/dy;
            %Hz(i,j,k) = Hz(i,j,k) + DB*psi_Hzy_1(i,j,k);
         %end
%.....................................................................
%  PML for top Hz, y-direction
%.....................................................................
         %jj = nyPML_2-1;
         %for j = Jmax+1-nyPML_2:Jmax-1
           % psi_Hzy_2(i,jj,k) = bh_y_2(jj)*psi_Hzy_2(i,jj,k)+ ch_y_2(jj)*(Ex(i,j+1,k) - Ex(i,j,k))/dy;
            %Hz(i,j,k) = Hz(i,j,k) + DB*psi_Hzy_2(i,jj,k);
            %jj = jj-1;
         %end
      %end
   %end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
%  UPDATE Ex
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   %for k = 2:Kmax-1
      %for i = 1:Imax-1
    %for j = 2:Jmax-1
             % if (i >= istart-1 && i <= iend && j >= jstart && j <= jend && k >= kstart && k <= kend)
                 %Ex(i,j,k) = 0.0;
              %else
          %Ex(i,j,k) = CA(i,j,k) * Ex(i,j,k) + CB(i,j,k) * ( (Hz(i,j,k) - Hz(i,j-1,k))*den_ey(j)  +  (Hy(i,j,k-1) - Hy(i,j,k))*den_ez(k) );
              %end
    %end
      %end
      %for i = 1:Imax-1
%.....................................................................
%  PML for bottom Ex, j-direction
%.....................................................................
        % for j = 2:nyPML_1
         %psi_Exy_1(i,j,k) = be_y_1(j)*psi_Exy_1(i,j,k)+ ce_y_1(j) *(Hz(i,j,k) - Hz(i,j-1,k))/dy;
         %Ex(i,j,k) = Ex(i,j,k) + CB(i,j,k)*psi_Exy_1(i,j,k);
         %end
%.....................................................................
%  PML for top Ex, j-direction
%.....................................................................
         %jj = nyPML_2;
         %for j = Jmax+1-nyPML_2:Jmax-1
         %psi_Exy_2(i,jj,k) = be_y_2(jj)*psi_Exy_2(i,jj,k)+ ce_y_2(jj) *(Hz(i,j,k) - Hz(i,(j-1),k))/dy;
         %Ex(i,j,k) = Ex(i,j,k) + CB(i,j,k)*psi_Exy_2(i,jj,k);
           % jj = jj-1;
         %end
      %end
   %end
   %for i = 1:Imax-1
     % for j = 2:Jmax-1
%.....................................................................
%  PML for bottom Ex, k-direction
%.....................................................................
       %  for k = 2:nzPML_1
        % psi_Exz_1(i,j,k) = be_z_1(k)*psi_Exz_1(i,j,k)+ ce_z_1(k) *(Hy(i,j,k-1) - Hy(i,j,k))/dz;
         %Ex(i,j,k) = Ex(i,j,k) + CB(i,j,k)*psi_Exz_1(i,j,k);
         %end
%.....................................................................
%  PML for top Ex, k-direction
%.....................................................................
        % kk = nzPML_2;
         %for k = Kmax-nzPML_2:Kmax-1
         %psi_Exz_2(i,j,kk) = be_z_2(kk)*psi_Exz_2(i,j,kk)+ ce_z_2(kk) *(Hy(i,j,k-1) - Hy(i,j,k))/dz;
         %Ex(i,j,k) = Ex(i,j,k) + CB(i,j,k)*psi_Exz_2(i,j,kk);
            %kk = kk-1;
         %end
      %end
   %end
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
%  UPDATE Ey
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   %for k = 2:Kmax-1
     % for i = 2:Imax-1
    %for j = 1:Jmax-1
         %     if (i >= istart && i <= iend && j >= jstart-1 && j <= jend && k >= kstart && k <= kend)
        %         Ey(i,j,k) = 0.0;
       %       else
      %           Ey(i,j,k) = CA(i,j,k) * Ey(i,j,k) + CB(i,j,k) *( (Hz(i-1,j,k) - Hz(i,j,k))*den_ex(i) +  (Hx(i,j,k) - Hx(i,j,k-1))*den_ez(k) );
     %         end
    %end
      %end
      %for j = 1:Jmax-1
%.....................................................................
%  PML for bottom Ey, i-direction
%.....................................................................
        % for i = 2:nxPML_1
       %psi_Eyx_1(i,j,k) = be_x_1(i)*psi_Eyx_1(i,j,k)+ ce_x_1(i)*(Hz(i-1,j,k) - Hz(i,j,k))/dx;
       %Ey(i,j,k) = Ey(i,j,k) + CB(i,j,k)*psi_Eyx_1(i,j,k);
        % end
%.....................................................................
%  PML for top Ey, i-direction
%.....................................................................
       %  ii = nxPML_2;
      %   for i = Imax+1-nxPML_2:Imax-1
       %psi_Eyx_2(ii,j,k) = be_x_2(ii)*psi_Eyx_2(ii,j,k)+ ce_x_2(ii)*(Hz(i-1,j,k) - Hz(i,j,k))/dx;
      % Ey(i,j,k) = Ey(i,j,k) + CB(i,j,k)*psi_Eyx_2(ii,j,k);
     %       ii = ii-1;
     %    end
    %  end
   %end
   %for i = 2:Imax-1
      %for j = 1:Jmax-1
%.....................................................................
%  PML for bottom Ey, k-direction
%.....................................................................
        % for k = 2:nzPML_1
       %psi_Eyz_1(i,j,k) = be_z_1(k)*psi_Eyz_1(i,j,k)+ ce_z_1(k)*(Hx(i,j,k) - Hx(i,j,k-1))/dz;
       %Ey(i,j,k) = Ey(i,j,k) + CB(i,j,k)*psi_Eyz_1(i,j,k);
         %end
%.....................................................................
%  PML for top Ey, k-direction
%.....................................................................
        % kk = nzPML_2;
       %  for k = Kmax-nzPML_2:Kmax-1;
     %psi_Eyz_2(i,j,kk) = be_z_2(kk)*psi_Eyz_2(i,j,kk)+ ce_z_2(kk)*(Hx(i,j,k) - Hx(i,j,k-1))/dz;
     %Ey(i,j,k) = Ey(i,j,k) + CB(i,j,k)*psi_Eyz_2(i,j,kk);
      %      kk = kk-1;
     %    end
    %  end
   %end

%-----------------------------------------------------------------------
%   SOURCE
%-----------------------------------------------------------------------
%Ez(isource01,jsource01,1:Kmax)=Ez(isource01,jsource01,1:Kmax)+srcconst*(n-ndelay)*exp(-((n-ndelay)^2/tau^2));
%Hz(isource02,jsource02,2:Kmax-1)=Hz(isource02,jsource02,2:Kmax-1)+srcconst*(n-ndelay)*exp(-((n-ndelay)^2/tau^2));
   
pcolor(Ez),colorbar
shading interp;
%axis equal;
view(90,90);
grid off;
%caxis([-0.00001 0.00001])
%axis([1 xdim 1 ydim -1 1])
set(gcf,'Color', 'white', 'Number', 'off', 'Name', sprintf('Simulacin FDTD, 2D, Iteracin = %i', n));
title(sprintf('E_{z}, SPML, t=%.3f nsec',n*dt*1e9),'Color',[1 0 0],'FontSize', 14); drawnow;
xlabel('Celdas FDTD');
ylabel('Celdas FDTD');

     

%pause(0.0001)
%ez_ref_max_a(n,1)=max(ez_ref_a);
%ez_ref_max_b(n,1)=max(ez_ref_b);

end

%max_a=max(ez_ref_max_a);
%max_b=max(ez_ref_max_b);
















